/*
 * Created on 28.05.2004
 *
 */
package sv.view;

import java.awt.Dialog;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import sv.Controller;

/**
 * @author florian
 *
 */
public class OptScreen extends JFrame {

	private JLabel lammo2;
	private Controller con;
	private JTextField fname, fport, furl;
	private JSlider sammo;
	private Dialog d;

	/**
	 * creates the option screen 
	 * @param con the controller by which the option screen was created ist set by this
	 */
	public OptScreen(Controller con){
		this.con = con;
		this.setSize(400,255);
		this.setLocation(50,50);
		this.setResizable(false);
		this.setTitle("Options for SV v0.1");
		this.getContentPane().setLayout(null);
		
		// Game Panel
		JPanel panel1 = new JPanel();
		panel1.setSize(385,90);
		panel1.setLocation(5,5);
		panel1.setLayout(null);
		panel1.setBorder(new TitledBorder("Game Information"));
		this.getContentPane().add(panel1);

		JLabel lname = new JLabel("Player Name:");
		lname.setSize(100,15);
		lname.setVisible(true);
		lname.setLocation(10,25);
		panel1.add(lname);
		
		fname = new JTextField("Player");
		fname.setSize(280,18);
		fname.setVisible(true);
		fname.setLocation(90,23);
		panel1.add(fname);

		JLabel lammo = new JLabel("Ammo Diff:");
		lammo.setSize(70,15);
		lammo.setVisible(true);
		lammo.setLocation(22,55);
		panel1.add(lammo);
		
		lammo2 = new JLabel("30");
		lammo2.setSize(110,15);
		lammo2.setVisible(true);
		lammo2.setLocation(255,55);
		panel1.add(lammo2);
		
		
		sammo = new JSlider(10, 100, 30);
		sammo.setVisible(true);
		sammo.setSize(135, 15);
		sammo.setLocation(90, 53);
		sammo.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent e){
				showStatus(((JSlider)e.getSource()).getValue());
					
			}
		});
		panel1.add(sammo);

		// Connection Panel
		JPanel panel2 = new JPanel();
		panel2.setSize(385,90);
		panel2.setLocation(5, 100);
		panel2.setLayout(null);
		panel2.setBorder(new TitledBorder("Connection Information"));
		this.getContentPane().add(panel2);
		
		JLabel lurl = new JLabel("URL or IP:");
		lurl.setSize(70,15);
		lurl.setVisible(true);
		lurl.setLocation(30,25);
		panel2.add(lurl);
		
		furl = new JTextField("localhost");
		furl.setSize(280,18);
		furl.setVisible(true);
		furl.setLocation(90,23);
		panel2.add(furl);

		JLabel lport = new JLabel("Port:");
		lport.setSize(70,15);
		lport.setVisible(true);
		lport.setLocation(57,55);
		panel2.add(lport);

		fport = new JTextField("40999");
		fport.setSize(80,18);
		fport.setVisible(true);
		fport.setLocation(90,53);
		panel2.add(fport);

		// The Buttons		
		JButton connect = new JButton("Connect");
		connect.setSize(120,20);
		connect.setLocation(75, 200);
		this.getContentPane().add(connect);
		connect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e){
				signalizeConnect();
			}
		});
			
		JButton serve = new JButton("Serve");
		serve.setSize(120,20);
		serve.setLocation(205, 200);
		this.getContentPane().add(serve);
		serve.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e){
				//System.out.println("Serve was clicked!");
				signalizeServe();
				createServingDialog();
			}
		});
		this.setVisible(true);
	}

	private void showStatus(int val){
		String txt = "" + val;
		lammo2.setText(txt);
	}

	private void signalizeConnect(){
		this.con.setInfo(this.fname.getText(), this.furl.getText(), this.fport.getText(), 0);
		this.con.setAction(Controller.CONNECT);
	}
	
	private void signalizeServe(){
		this.con.setInfo(this.fname.getText(), null, this.fport.getText(), this.sammo.getValue());
		this.con.setAction(Controller.SERVE);
	}
	
	/**
	 * Creates dialog which informs about the serving status and offers the possiblity to abort the process. 
	 *
	 */
	public void createServingDialog(){
		this.d = new Dialog(this, "Serving ... ", true);
		d.setSize(300, 120);
		d.setLocation(this.getLocationOnScreen().x + 50, this.getLocationOnScreen().y + 50);
		d.setResizable(false);
		JPanel content = new JPanel();
		content.setSize(300,120);
		content.setVisible(true);
		d.add(content);
		JButton abort = new JButton("Abort");
		abort.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e){
				System.out.println("Aborted from OptScreen ...");
				System.exit(0);
			}
		});
		abort.setLocation(10, 10);
		abort.setVisible(true);
		content.add(abort);
		JLabel msg = new JLabel("Waiting for other player ... ");
		msg.setLocation(50, 50);
		content.add(msg);
		d.repaint();
		d.setVisible(true);
	}
	
	/**
	 * disposes the dialog
	 *
	 */
	public void disposeDialog(){
		if (this.d != null){
			d.dispose();
		}
	}
}
